      function cosh (x)
c august 1977 edition.  w. fullerton, c3, los alamos scientific lab.
c
      external exp, r1mach, sqrt
      data ymax / 0.0 /
c
      if (ymax.eq.0.0) ymax = 1.0/sqrt(r1mach(3))
c
      y = exp(abs(x))
      cosh = 0.5*y
      if (y.lt.ymax) cosh = 0.5 * (y + 1.0/y)
c
      return
      end
